<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover { 
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_READYSTATE_FINISH_RESPONSE_READY = 4;
    const gREQUEST_STATUS_OK = 200;

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function() {
        $("#btn-dice").click(onBtnDiceClick);
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm click button Ném
    function onBtnDiceClick() {
        "use strict";
        var vUser = {
            username: "",
            firstname: "",
            lastname: "",
        }
        // B1: đọc dữ liệu user
        readData(vUser);
        // B2: kiểm tra data
        var vIsValid = validate(vUser);
        if (vIsValid) {
            var vXmlHttpDice = new XMLHttpRequest();
            // B3: Call API
            callAPIDice(vXmlHttpDice, vUser);
            vXmlHttpDice.onreadystatechange = 
                function() {
                    if (this.readyState == gREQUEST_READYSTATE_FINISH_RESPONSE_READY 
                        && this.status == gREQUEST_STATUS_OK) {
                            // B4: hiển thị dữ liệu
                            console.log(vXmlHttpDice.responseText);
                            handlerDiceResponse(vXmlHttpDice);
                    }
                }
        }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm đọc dữ liệu user
    function readData(paramUser) {
        "use strict";        
        paramUser.username = $("#inp-user-name").val().trim();
        paramUser.firstname = $("#inp-first-name").val().trim();
        paramUser.lastname = $("#inp-last-name").val().trim(); 
        /*
        var vElmUsername = $("#inp-user-name");
        var vElmFirstname = $("#inp-first-name");
        var vElmLastname = $("#inp-last-name");
        paramUser.username = $.trim(vElmUsername.val());
        paramUser.firstname = $.trim(vElmFirstname.val());
        paramUser.lastname = $.trim(vElmLastname.val());
        */
    }
    // Hàm kiểm tra dữ liệu 
    function validate(paramUser) {
        "use strict";
        if (paramUser.username === "") {
            console.log("Xin nhập username");
            return false;
        }
        if (paramUser.firstname === "") {
            console.log("Xin nhập firstname");
            return false;
        }
        if (paramUser.lastname === "") {
            console.log("Xin nhập lastname");
            return false;
        }
        return true;
    }
    // Call API dice request
    function callAPIDice(paramXmlHttp, paramUser) {
        "use strict";
        const vBaseUrl = "http://203.171.20.210:8080/devcamp-lucky-dice/";
        const vUtf8TextApplicationHeader = "application/json;charset=UTF-8";
        paramXmlHttp.open("POST", vBaseUrl + "/dice", true)
        paramXmlHttp.setRequestHeader("Content-Type", vUtf8TextApplicationHeader);
        paramXmlHttp.send(JSON.stringify(paramUser))
    }
    // Hàm xử lý Dice responese 
    function handlerDiceResponse(paramXmlHttp) {
        "use strict";
        var vDiceObj = JSON.parse(paramXmlHttp.responseText);
        console.log("Dice result: " + vDiceObj.dice);
        var vDiceResult = vDiceObj.dice;
        // Hàm thay đổi hình khi quay số
        changeDiceImage(vDiceResult);
        // Hàm thay đổi lời nhắn khi quay số
        changeNotificationMessage(vDiceResult);
        // Hàm hiển thị voucher 
        changeVoucher(vDiceObj);
        // Hàm hiển thị prize
        changePrize(vDiceObj);
    }
    // Hàm thay đổi image theo dice result 
    function changeDiceImage(paramDiceResult) {
        "use strict";
        var vElmDiceImg = $("#img-dice");
        switch(paramDiceResult) {
            case 1: 
                vElmDiceImg.attr("src", "LuckyDiceImages/1.png");
                break;
            case 2:
                vElmDiceImg.attr("src", "LuckyDiceImages/2.png");
                break;
            case 3:
                vElmDiceImg.attr("src", "LuckyDiceImages/3.png");
                break;
            case 4:
                vElmDiceImg.attr("src", "LuckyDiceImages/4.png");
                break;
            case 5:
                vElmDiceImg.attr("src", "LuckyDiceImages/5.png");
                break;
            default:
                vElmDiceImg.attr("src", "LuckyDiceImages/6.png");                
        } 
    }
    // Hàm thay đổi notification theo dice result 
    function changeNotificationMessage(paramDiceResult) {
        "use strict";
        var vElmNotification = $("#p-notification-dice");
        if (paramDiceResult < 4) {
            vElmNotification.html("Chúc bạn may mắn lần sau");
        } else {
            vElmNotification.html("Chúc mừng bạn! hãy chơi tiếp lần nữa !!!");
        }
    }
    // Hàm thay đổi voucher 
    function changeVoucher(paramDiceObj) {
        "use strict";
        var vElmVoucher = $("#p-voucher-id");
        var vElmVoucherPercent = $("#p-voucher-percent");

        if (paramDiceObj.voucher != null) {
            vElmVoucher.html(paramDiceObj.voucher.maVoucher);
            vElmVoucherPercent.html(paramDiceObj.voucher.phanTramGiamGia + "%");
        } else {
            vElmVoucher.html("");
            vElmVoucherPercent.html("");
        }
    }
    // Hàm hiển thị prize
    function changePrize(paramDiceObj) {
        "use strict";
        var vDicePrize = paramDiceObj.prize
        var vElmPrize = $("#img-present");
        switch(vDicePrize) {
            case "Áo mưa":
                vElmPrize.attr("src", "LuckyDiceImages/rainCoat.png");
                break;
            case "Áo":
                vElmPrize.attr("src", "LuckyDiceImages/t-shirt.jpg");
                break;
            case "Xe máy":
                vElmPrize.attr("src", "LuckyDiceImages/xe-may.jpg");
                break;
            case "Ô tô":
                vElmPrize.attr("src", "LuckyDiceImages/car.jpg");
                break;
            case "Bút":
                vElmPrize.attr("src", "LuckyDiceImages/pen.jfif");
                break;
            case "Mũ":
                vElmPrize.attr("src", "LuckyDiceImages/hat.jpg");
                break;
            default:
                vElmPrize.attr("src", "LuckyDiceImages/no-present.jpg");                
        }
    }

</script>

<body>
    <div class="container-fluid  picture-cover">
        
    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12"> <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">  <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"><!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center"> <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center"> <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group"> <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row "> <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>
<script>

</script>

</html>